<%

'----------------------------------------------------------

' Namo WebEditor dbWizard Script.
' Copyright 2000 Namo Interacive Inc. All Rights Reserved.
'
'<!--#include file="wed_asp_ODBC.inc"-->

'----------------------------------------------------------

const WED_NULL_STR      = ""
const WED_NULL_INT      = -1
const WED_CUR_DATE      = ""
const WED_MAX_INT       = 32767
const WED_MAX_PAGE      = 10
const WED_CURSOR_TYPE   = 2     'adOpenStatic

'----------------------------------------------------------

sub wed_input_int(name, value, maxlength, size)
    response.write("<input type=""text""")
    if (name <> WED_NULL_STR) then
       response.write(" name=""" & name & """")
    end if
    if (value <> WED_NULL_INT) then
       response.write(" value=""" & value & """")
    end if
    if (maxlength <> WED_NULL_INT) then
       response.write(" maxlength=""" & maxlength & """")
    end if
    if (size <> WED_NULL_INT) then
       response.write(" size=""" & size & """")
    end if
    response.write(" onChange=""wed_check_int(this)"">")
end sub

'----------------------------------------------------------

sub wed_input_str(name, value, maxlength, size)
    response.write("<input type=""text""")
    if (name <> WED_NULL_STR) then
       response.write(" name=""" & name & """")
    end if
    if (value <> WED_NULL_STR) then
       response.write(" value=""" & value & """")
    end if
    if (maxlength <> WED_NULL_INT) then
       response.write(" maxlength=""" & maxlength & """")
    end if
    if (size <> WED_NULL_INT) then
       response.write(" size=""" & size & """")
    end if
    response.write(">")
end sub

'----------------------------------------------------------

sub wed_input_text(name, value, rows, cols)
    response.write("<textarea")
    if (name <> WED_NULL_STR) then
       response.write(" name=""" & name & """")
    end if
    if (rows <> WED_NULL_INT) then
       response.write(" rows=""" & rows & """")
    end if
    if (cols <> WED_NULL_INT) then
       response.write(" cols=""" & cols & """")
    end if
    response.write(">")
    if (value <> WED_NULL_STR) then
       response.write(value)
    end if
    response.write("</textarea>")
end sub

'----------------------------------------------------------

sub wed_input_hidden(name, value)
    response.write("<input type=""hidden""")
    if (name <> WED_NULL_STR) then
       response.write(" name=""" & name & """")
    end if
    if (value <> WED_NULL_STR) then
       response.write(" value=""" & value & """")
    end if
    response.write(">")

    if not isnull(value) then
        w_value = replace(value, vbcr, "<br>")
    end if
    response.write(w_value)
end sub

'----------------------------------------------------------

sub wed_input_combo(servername, userid, passwd, sqlstr, name, valuefield, stringfield, selectvalue)
    dim db, cursor, record, i, value, str

    set db = server.createobject("adodb.connection")
    db.open servername, userid, passwd
    set cursor = server.CreateObject("adodb.recordset")
    cursor.cursortype = WED_CURSOR_TYPE
    cursor.open sqlstr, db

    record = cursor.getrows

    response.write("<select name=""" & name & """>")
    response.write(vbcrlf)
    for i = 0 to ubound(record, 2)
        value = record(valuefield, i)
        str   = record(stringfield, i)
        if (value = selectvalue) then
            response.write("<option selected value=""" & value & """>" & str)
            response.write(vbcrlf)
        else
            response.write("<option value=""" & value & """>" & str)
            response.write(vbcrlf)
        end if
    next
    response.write("</select>")

    cursor.close
    db.close
    set cursor = nothing
    set db = nothing
end sub

'----------------------------------------------------------

sub wed_input_radio(servername, userid, passwd, sqlstr, name, valuefield, stringfield, selectvalue)
    dim db, cursor, record, i, value, str

    set db = server.createobject("adodb.connection")
    db.open servername, userid, passwd
    set cursor = server.CreateObject("adodb.recordset")
    cursor.cursortype = WED_CURSOR_TYPE
    cursor.open sqlstr, db

    record = cursor.getrows

    for i = 0 to ubound(record, 2)
        value = record(valuefield, i)
        str   = record(stringfield, i)
        if (i = 0) then
            response.write("<p>")
        else
            response.write("<br>")
        end if
        if (value = selectvalue) then
            response.write("<input type=""radio"" name=""" & name & """ value=""" & value & """ checked>" & str)
            response.write(vbcrlf)
        else
            response.write("<input type=""radio"" name=""" & name & """ value=""" & value & """>" & str)
            response.write(vbcrlf)
        end if
    next

    cursor.close
    db.close
    set cursor = nothing
    set db = nothing
end sub

'----------------------------------------------------------

sub write_option(startval, endval, selectval)
    dim i

    for i = startval to endval
        if (i = selectval) then
            if (i < 10) then
            	response.write("<option value=""" & i & """ selected>0" & i & vbcrlf)
            else
            response.write("<option value=""" & i & """ selected>" & i & vbcrlf)
			end if
        else
            if (i < 10) then
	            response.write("<option value=""" & i & """>0" & i & vbcrlf)
        else
            response.write("<option value=""" & i & """>" & i & vbcrlf)
        end if
        end if
    next
end sub

'----------------------------------------------------------

sub wed_input_date(name, value, intfmt)
    dim yy, mm, dd, hh, mi
    dim i, j, tmp, strlen, locidx(3, 5), fmtstr(6), prevpos

    if (value = WED_CUR_DATE) then
        value = date() + time()
    end if

    yy = year(value)
    mm = month(value)
    dd = day(value)
    hh = hour(value)
    mi = minute(value)

    if (intfmt = WED_NULL_STR) then
        intfmt = "mm/dd/yy hh:mi"
    end if

    locidx(0, 0) = instr(intfmt, "yy")
    locidx(0, 1) = instr(intfmt, "mm")
    locidx(0, 2) = instr(intfmt, "dd")
    locidx(0, 3) = instr(intfmt, "hh")
    locidx(0, 4) = instr(intfmt, "mi")

    for i = 0 to 4
        if (locidx(0, i) = 0) then
            locidx(0, i) = WED_MAX_INT
        end if
        locidx(1, i) = i + 1
        locidx(2, i) = 0
    next

    for i = 0 to 4
        for j = (i + 1) to 4
            if (locidx(0, i) > locidx(0, j)) then
                tmp = locidx(0, i)
                locidx(0, i) = locidx(0, j)
                locidx(0, j) = tmp

                tmp = locidx(1, i)
                locidx(1, i) = locidx(1, j)
                locidx(1, j) = tmp
            end if
        next
    next

    for i = 0 to 4
        for j = 0 to 4
            if (locidx(1, j) = (i + 1)) then
                locidx(2, i) = j + 1
            end if
        next
    next

    for i = 0 to 4
        if (locidx(0, locidx(2, i) - 1) = WED_MAX_INT) then
            locidx(2, i) = WED_NULL_INT
        end if
    next

    prevpos = 1
    for i = 0 to 4
        if (locidx(0, i) <> 0) then
            if (prevpos < locidx(0, i)) then
                fmtstr(i) = mid(intfmt, prevpos, locidx(0, i) - prevpos)
                prevpos = locidx(0, i)
            end if
            prevpos = prevpos + 2
        end if
    next

    if (prevpos <= len(intfmt)) then
        fmtstr(5) = mid(intfmt, prevpos, len(intfmt) - prevpos + 1)
    end if

    ' Always define "hidden" first. ("index mark" is used in JavaScript.)

    response.write("<input type=""hidden"" name=""" & name & """ value=""" & yy & "-" & mm & "-" & dd & " " & hh & ":" & mi & """>")

    response.write(fmtstr(0))
    for i = 0 to 4
        if (locidx(0, i) <> WED_MAX_INT) then
            select case (locidx(1, i))
                case 1
                    response.write("<select value=""" & yy & """ onChange=""wed_check_date(this, this.form." & name & ", " & locidx(2, 0) & ", " & locidx(2, 1) & ", " & locidx(2, 2) & ", " & locidx(2, 3) & ", " & locidx(2, 4) & ")"">" & vbcrlf)
                    'response.write("<option value=""1"">year" & vbcrlf)
                    write_option 1900, 2010, yy
                    response.write("</select>")
                case 2
                    response.write("<select value=""" & mm & """ onChange=""wed_check_date(this, this.form." & name & ", " & locidx(2, 0) & ", " & locidx(2, 1) & ", " & locidx(2, 2) & ", " & locidx(2, 3) & ", " & locidx(2, 4) & ")"">" & vbcrlf)
                    'response.write("<option value=""1"">month" & vbcrlf)
                    write_option 1, 12, mm
                    response.write("</select>")
                case 3
                    response.write("<select value=""" & dd & """ onChange=""wed_check_date(this, this.form." & name & ", " & locidx(2, 0) & ", " & locidx(2, 1) & ", " & locidx(2, 2) & ", " & locidx(2, 3) & ", " & locidx(2, 4) & ")"">" & vbcrlf)
                    'response.write("<option value=""1"">day" & vbcrlf)
                    if (mm = 2) then
                        if ((yy mod 400 = 0) or ((yy mod 4 = 0) and (yy mod 100 <> 0))) then
                            write_option 1, 29, dd
                        else
                            write_option 1, 28, dd
                        end if
                    else
                        if (mm = 4 or mm = 6 or mm = 9 or mm = 11) then
                            write_option 1, 30, dd
                        else
                            write_option 1, 31, dd
                        end if
                    end if
                    response.write("</select>")
                case 4
                    response.write("<select value=""" & hh & """ onChange=""wed_check_date(this, this.form." & name & ", " & locidx(2, 0) & ", " & locidx(2, 1) & ", " & locidx(2, 2) & ", " & locidx(2, 3) & ", " & locidx(2, 4) & ")"">" & vbcrlf)
                    'response.write("<option value=""1"">hour" & vbcrlf)
                    write_option 0, 23, hh
                    response.write("</select>")
                case 5
                    response.write("<select value=""" & mi & """ onChange=""wed_check_date(this, this.form." & name & ", " & locidx(2, 0) & ", " & locidx(2, 1) & ", " & locidx(2, 2) & ", " & locidx(2, 3) & ", " & locidx(2, 4) & ")"">" & vbcrlf)
                    'response.write("<option value=""1"">minute" & vbcrlf)
                    write_option 0, 59, mi
                    response.write("</select>")
            end select
            response.write(fmtstr(i+1))
        end if
    next
end sub

'----------------------------------------------------------

sub wed_list_move_page(disppages, disprows, startrow, maxrows)
    dim url, page, curpage, startpage, endpage, maxpages

    url = request.servervariables("url")

    curpage   = startrow \ disprows
    maxpages  = (maxrows + disprows - 1) \ disprows

    if (maxpages < disppages) then
        startpage = 0
        endpage   = maxpages - 1
    else
        endpage   = curpage + (disppages \ 2)
        startpage = endpage - disppages + 1

        if (startpage < 0) then
            endpage   = endpage - startpage
            startpage = 0
        end if
        if (maxpages <= endpage) then
            startpage = startpage - (endpage - maxpages + 1)
            endpage   = maxpages - 1
        end if
    end if

    if (0 < curpage) then
        response.write("[<a href=""" & url & "?startrow=" & (curpage-1) * disprows & "&maxrows=" & maxrows & """>" & "<<" & "</a>]" & vbcrlf)
    end if
    response.write("[" & vbcrlf)
    if (0 < startpage) then
        response.write("<a href=""" & url & "?startrow=" & 0 & "&maxrows=" & maxrows & """>" & 1 & "</a> " & vbcrlf)
    end if
    if (1 < startpage) then
        response.write("..." & vbcrlf)
    end if
    for page = startpage to endpage
        if (page = curpage) then
            response.write("<b>" & (page + 1) & "</b> " & vbcrlf)
        else
            response.write("<a href=""" & url & "?startrow=" & (page * disprows) & "&maxrows=" & maxrows & """>" & (page + 1) & "</a> " & vbcrlf)
        end if
    next
    if (endpage < (maxpages-2)) then
        response.write("..." & vbcrlf)
    end if
    if (endpage < (maxpages-1)) then
        response.write("<a href=""" & url & "?startrow=" & ((maxpages - 1) * disprows) & "&maxrows=" & maxrows & """>" & maxpages & "</a>" & vbcrlf)
    end if
    response.write("]" & vbcrlf)
    if (curpage < (maxpages-1)) then
        response.write("[<a href=""" & url & "?startrow=" & (curpage+1) * disprows & "&maxrows=" & maxrows & """>" & ">>" & "</a>]" & vbcrlf)
    end if
end sub

'----------------------------------------------------------

sub wed_db_process(servername, userid, passwd, sqlstr)
    dim db

    set db = server.createobject("adodb.connection")
    db.open servername, userid, passwd
    db.execute(sqlstr)
    db.close
    set db = nothing
end sub

'----------------------------------------------------------

sub wed_read_process(servername, userid, passwd, sqlstr, byref record)
    dim db, cursor

    set db = server.createobject("adodb.connection")
    db.open servername, userid, passwd
    set cursor = server.CreateObject("adodb.recordset")
    cursor.cursortype = WED_CURSOR_TYPE
    cursor.open sqlstr, db
    record = cursor.getrows
    cursor.close
    db.close
    set cursor = nothing
    set db = nothing
end sub

'----------------------------------------------------------

sub wed_read_list_process(servername, userid, passwd, sqlstr, byref record, disprows, startrow, byref maxrows, byref rows)
    dim db, cursor, dummyrecord

    set db = server.createobject("adodb.connection")
    db.open servername, userid, passwd
    set cursor = server.CreateObject("adodb.recordset")
    cursor.cursortype = WED_CURSOR_TYPE
    cursor.open sqlstr, db

    if (0 < startrow) then
        cursor.move(startrow)
    end if

    record = cursor.getrows(disprows)
    rows   = ubound(record, 2)

    if (maxrows = 0) then
        if (cursor.eof) then
            maxrows = startrow + rows + 1
        else
            dummyrecord = cursor.getrows
            maxrows = startrow + rows + 1 + ubound(dummyrecord, 2) + 1
        end if
    end if

    cursor.close
    db.close
    set cursor = nothing
    set db = nothing
end sub

'----------------------------------------------------------

sub wed_write(value)
    if not isnull(value) then
        w_value = replace(value, vbcr, "<br>")
    end if
    response.write(w_value)
end sub

'----------------------------------------------------------

sub wed_write_link(link, argname, argvalue, value)
    response.write("<a href=""" & link & "?" & argname & "=" & argvalue & """>")
    response.write(value)
    response.write("</a>")
end sub

'----------------------------------------------------------

sub wed_chart_process1(servername, userid, passwd, sqlstr, legend, xcol, value_field, chart_style, img_url, img_option)
    dim db, cursor, record, rows, i, j, k

    set db = server.createobject("adodb.connection")
    db.open servername, userid, passwd
    set cursor = db.execute(sqlstr)
    record = cursor.getrows
    cursor.close
    db.close
    set cursor = nothing
    set db = nothing

    response.write("<img src=""" & img_url & "?")
    rows = ubound(record, 2)

    k = 0
    for i = 0 to legend - 1
        response.write(i + 1 & "d=,{")
        for j = 0 to xcol - 1
            if k < rows then
                response.write(record(value_field, k))
            end if
            response.write(",")
            k = k + 1
        next
        response.write("},&")
    next
    response.write(chart_style & """ " & img_option & ">" & vbcr)
end sub

'----------------------------------------------------------

function find_str(data, str)
    dim i, items

    items = ubound(data, 1)
    find_str = -1

    for i = 0 to items - 1
        if StrComp(data(i), str) = 0 then
            find_str = i
        end if
    next
end function

sub wed_chart_process2(servername, userid, passwd, sqlstr, legend_field, xcol_field, value_field, chart_style, img_url, img_option)
    dim db, cursor, record, rows
    dim legend, xcol, legend_data(), xcol_data()
    dim i, j, k, value_data

    set db = server.createobject("adodb.connection")
    db.open servername, userid, passwd
    set cursor = db.execute(sqlstr)
    record = cursor.getrows
    cursor.close
    db.close
    set cursor = nothing
    set db = nothing

    rows = ubound(record, 2)

    redim preserve legend_data(1)
    redim preserve xcol_data(1)

    for i = 0 to rows
        legend = find_str(legend_data, record(legend_field, i))
        if legend = -1 then
            legend = ubound(legend_data, 1)
            redim preserve legend_data(legend + 1)
            legend_data(legend-1) = record(legend_field, i)
        end if
        xcol   = find_str(xcol_data, record(xcol_field, i))
        if xcol = -1 then
            xcol = ubound(xcol_data, 1)
            redim preserve xcol_data(xcol + 1)
            xcol_data(xcol-1) = record(xcol_field, i)
        end if
    next

    legend = ubound(legend_data, 1) - 1
    xcol   = ubound(xcol_data, 1) - 1
    redim value_data(legend, xcol)

    for i = 0 to rows
        legend = find_str(legend_data, record(legend_field, i))
        xcol   = find_str(xcol_data, record(xcol_field, i))
        value_data(legend, xcol) = record(value_field, i)
    next

    legend = ubound(legend_data, 1) - 1
    xcol   = ubound(xcol_data, 1) - 1

    response.write("<img src=""" & img_url & "?")
    response.write("xd=")
    for i = 0 to xcol - 1
        response.write(xcol_data(i) & ",")
    next
    response.write("&")
    for i = 0 to legend - 1
        response.write(i + 1 & "d=" & legend_data(i) & ",{")
        for j = 0 to xcol - 1
            response.write(value_data(i, j) & ",")
        next
        response.write("},&")
    next
    response.write(chart_style & """ " & img_option & ">" & vbcr)
end sub

'----------------------------------------------------------

%>

<SCRIPT LANGUAGE="JavaScript">
<!--
function wed_check_int(e)
{
}

function wed_check_date(e, h, yy_idx, mm_idx, dd_idx, hh_idx, mi_idx)
{
    var base_idx, yy, mm, dd, hh, mi, i, days, new_option

    for (base_idx = 0; base_idx < e.form.length; base_idx++)
        if (e.form.elements[base_idx] == h) break
    if (e.form.length <= base_idx) return 0

    if (yy_idx != -1) yy = e.form.elements[base_idx + yy_idx].options[e.form.elements[base_idx + yy_idx].selectedIndex].value
    if (mm_idx != -1) mm = e.form.elements[base_idx + mm_idx].options[e.form.elements[base_idx + mm_idx].selectedIndex].value
    if (dd_idx != -1) dd = e.form.elements[base_idx + dd_idx].options[e.form.elements[base_idx + dd_idx].selectedIndex].value
    if (hh_idx != -1) hh = e.form.elements[base_idx + hh_idx].options[e.form.elements[base_idx + hh_idx].selectedIndex].value
    if (mi_idx != -1) mi = e.form.elements[base_idx + mi_idx].options[e.form.elements[base_idx + mi_idx].selectedIndex].value

    if (dd_idx != -1 && mm_idx != -1 && yy_idx != -1) {
        if (mm == 2) {
            if ((yy % 400 == 0) || ((yy % 4 == 0) && (yy % 100 != 0))) {
                days = 29
            } else {
                days = 28
            }
        } else {
            if (mm == 4 || mm == 6 || mm == 9 || mm == 11) {
                days = 30
            } else {
                days = 31
            }
        }
        if (days != e.form.elements[base_idx + dd_idx].length) {
            e.form.elements[base_idx + dd_idx].length = 0
            for (i = 0; i < days; i++) {
                new_option = new Option(i + 1, i + 1)
                e.form.elements[base_idx + dd_idx].options[i] = new_option
            }
            e.form.elements[base_idx + dd_idx].selectedIndex = dd - 1
        }
    }

    h.value = ''

    if (yy_idx != -1) h.value = yy
    if (mm_idx != -1) h.value = h.value + '-' + mm
    if (dd_idx != -1) h.value = h.value + '-' + dd
    if (hh_idx != -1) h.value = h.value + ' ' + hh
    if (mi_idx != -1) h.value = h.value + ':' + mi

    return 1
}

//-->
</SCRIPT>
